/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"                      // Include simple tools
#include "fdserial.h"


  char tempf[20];

 char DATSTRING[100];
 char gpsraw;
// char nmea[100];
 char nmeadata[100];
 char rmcdata[100];
 char g_gganame[6];
 
 
//zulu time strutcure 
struct nmea {
 volatile int hrs;
 volatile int min;
 volatile int sec;
}zulu;  

//longitude structure
char rmcdata[100];


//latitude structure
struct latitude {
 volatile float lat;
volatile  int latdeg;
  double fractpart;
  float latmin;
  int latsec;
  float latmintemp;
  double param;
  double   intpart; //for parsing the latitude
}_lat;
  
//satellite data

char satnum[2];
char satfix[2];
int _fix;
int _numsats;



//earth data
  char _dilut[3];
  char alt[6];
  char alt_char[2];
  char _geoid[4];
  char _gchar[2];
  float Gsep;//geoidal separation
  float _alt;
  float diluted;
  
  
  
//longitude structure
float longitude;
int longdeg;
float longmin;
int longsec;
float longmintemp;
double longparam;
double longintpart;
double longfractpart;
int longintmin;
 
 
 
 

 
 
 int gpstime; 

 
 
 //volatile char fix;
 
 
  char nmealat[8];
//  float nmealat;
  char  lat_fix[1];
  char nmealong[20];
  char  L_R_fix[20];
 
  

// volatile float _dilut[6];

  int latmins; 
  
  
//gps driver forward declaration

 void getdata2(); //receive data from gps
  

// rmc variables
char rmcdata2[100];
char _rmcname[6];
int _rmctime;
float _rmclat;

char _rmcsat[2];
float _rmclong;
char _rmcNSchar[1];
char _rmcew[2];
float _rmcspeed;
float _rmccourse;
int _rmcdate;
char _rmcmagvar[6];


// date variables

float julian_date();  

float decimalday();
int day;
int month;
int year;
int tempdate;
float JD;
int UT;
float decimal_day;
int _gmathrs;
int JD_adder;
int A;
int B;
 float decday;

 int temphours;
     int tempmins;
float _decday;

// time variables
float GMST;
//special forward declaratins


// rmc forward declarations 
 void parcermc();
 char rmcname();
 int rmctime();
 void rmcsat();
 float rmclat();
 char rmcudchar();
 float rmclong();
char rmcewchar();
 float speed();
 float course();
 int date();
 char magvar();
 int fulldate();
 
 
// gga forward declarations
 void parcegga();
 
 char gganame();
 
 int ggatime();
 
 int ggalat();
 char updown();
 char ggalong();
 char leftright();
 int fix();
 int numsat();
 char dilut();
 float altitude();
 char meters();
 char meters();
 float geoid();
 char geoidunits();
 
//gps pins 
int rx_pin = 26;
int tx_pin = 27;
int mode_ = 0;
int Baud_rate = 9600;


int  cog;

unsigned int stack[128]; 

fdserial *GPS;  //MASK FOR THE FDSERIAL INPUT



int main()                                    // Main function



{
  // Add startup code here.
 GPS = fdserial_open(rx_pin,tx_pin,mode_ ,Baud_rate);
 cog=cogstart(getdata2,NULL,stack,sizeof(stack)); //this will not work
 
 
  while(1)
  {
 
   // print("%c",HOME);
    
    
//TIME SECTION   
     print("UTC TIME %d:%d:%d\n  ",zulu.hrs,zulu.min,zulu.sec);
     
     print("G M ASTRONOMICAL TIME %d:%d:%d\n",_gmathrs,zulu.min,zulu.sec);
     
     
     
//LATTITUDE
       
           
   //   print("Lattitude: %d %d  %f  %s\n\n", _lat.latdeg,latmins,_lat.fractpart*60,lat_fix); //works
          

//LONGITUDE

  //   print("Longitude: %d  %d  %f  %s\n\n  ", longdeg,longintmin,longfractpart*60,L_R_fix);
                                                                                
                                                                                
                                                                                
//SATELLITE DATA SECTION       
  // print("satellite fix  %s  %d\n\n",satfix,_fix);
     
  //  print("numsats        %s  %d\n\n",satnum,_numsats);
     
  //  print("dilution       %s   %f\n\n",_dilut,diluted);


//ALTITUDE     
 //   print("altitude       %s   %f\n\n",alt,_alt);
     
  //  print("meters         %s\n\n",alt_char);
       
  //  print("geoid          %s  %f \n\n",_geoid,Gsep);
    
    
   // print("geoid units %s\n\n",_gchar);
    
//RMC SPEED AND COURSE   
   
  //   print("rmc speed %f\n\n",_rmcspeed);
  //  print("rmc course %f\n\n", _rmccourse);
 //   print("UTC date %d\n\n",_rmcdate);
  //  print("rmc magvar %s\n\n", _rmcmagvar);
  
  
 
//JULIAN DAY SECTION
 //  print("JD_adder %d\n\n",JD_adder);
 //  print("A %d\n\n",A); 
  //  print("B %d\n\n",B);
  
  
   // print("JD %0.2f\n",JD);
    
    

 //  print("_gmathrs     %d\n\n", _gmathrs);
// print("decimal_day     %f\n\n", decimal_day);//component full decimal
//    print("decimal_day     %f\n\n", decday); //combined full decimal 



    // print("decimal day     %0.2f\n\n", _decday);//combined with decimal to two places %0.2f 
     
     
        //  print("GMST     %f\n\n", GMST); 
     
  // dec_da
    
  //  print("%c",NL);
  
 //  print("%d",BKSP);
 //   print("%d",CLREOL);
    print("%c",HOME);
    pause(500);
    
    
  }  
}




void getdata2()

{
  while(1)

{
    //read in characters from the GPS
    int idx = 0;
    do
    {
        gpsraw = fdserial_rxChar(GPS);
        DATSTRING[idx++] = gpsraw;      
    } while(gpsraw != 13 && gpsraw != 10);
    DATSTRING[idx] = 0;      //null terminate
    
    if(strncmp(DATSTRING,"$GPRMC",6) == 0)
      // strcpy(nmea,RMC);
       parcermc();
    if(strncmp(DATSTRING,"$GPGGA",6) == 0)
      // strcpy(nmea,RMC);
       parcegga();
       
   // print(RMC);
   
}
   

 
}

void parcermc()

{
  
 // strcpy(rmcdata,DATSTRING);
  strcpy(rmcdata2,DATSTRING);
 // strcpy(rmcname,strtok(rmcdata2, ","));
  
 // strcpy(nmea,DATSTRING);
    rmcname();
    rmctime();
    rmcsat();
    rmclat();
    rmcudchar();
    rmclong();
    rmcewchar();
    speed();
   // course();
    date();
    magvar();
    julian_date();
    decimalday();
   
}

char rmcname()


{
  
  strcpy(_rmcname,strtok(rmcdata2, ","));
  
  
} 

int rmctime()


{
  
 // strcpy(_rmctime,strtok(NULL, ","));
  _rmctime=atoi(strcpy( tempf,strtok(NULL, ","))); 
   // _rmctime=atoi(tempf);
  
}



void rmcsat()


{
  
  strcpy(_rmcsat,strtok(NULL, ","));
  
  
}


float rmclat()


{
  
 // strcpy(_rmclat,strtok(NULL, ","));
   _rmclat=atof(strcpy( tempf,strtok(NULL, ","))); 
   // _rmclat=atof(tempf);
  
}


char rmcudchar()


{
  
  strcpy(_rmcNSchar,strtok(NULL, ","));
  
  
}

float rmclong()


{
  
 // strcpy(_rmclong,strtok(NULL, ","));
   strcpy( tempf,strtok(NULL, ",")); 
    _rmclong=atof(tempf);
  
}


char rmcewchar()
{
  
  strcpy(_rmcew,strtok(NULL, ","));
  
  
}


float speed()
{
  
 // strcpy(_rmcspeed,strtok(NULL, ","));
   strcpy( tempf,strtok(NULL, ",")); 
    _rmcspeed=atof(tempf);
  
}

float course()
{
  
 // strcpy( _rmccourse,strtok(NULL, ","));
  strcpy( tempf,strtok(NULL, ",")); 
    _rmccourse=atof(tempf);
  
}

int date()
{
  
 // strcpy( _rmcdate,strtok(NULL, ","));
  
 // _rmcdate=strcpy(atoi(tempf,strtok(NULL, ",")));
  strcpy( tempf,strtok(NULL, ",")); 
    _rmcdate=atoi(tempf);
    
    fulldate( _rmcdate);
}

char magvar()
{
  
  strcpy(_rmcmagvar,strtok(NULL, ","));
  
  
}

//*******GPGGA PARSING SECTION*********//
//*************************************//
//*************************************//
  

void parcegga()

{
  
  strcpy(nmeadata,DATSTRING);
  
 
   gganame();
   ggatime();
   ggalat();
   updown();
   ggalong();
   leftright();
   fix();
   numsat();
   dilut();
   altitude();
   meters();
   geoid();
   geoidunits();
}



char gganame()


{
  
  strcpy(g_gganame,strtok(nmeadata, ","));
  
  
}  

int ggatime()


{
  float _gmst;
  int  d = (JD - 2451545.0 );
  int T = (d/36525);
 //parse out the time this is UTC time
  
   gpstime = atoi(  strcpy( tempf,strtok(NULL, ",")));
 // strcpy(gpstime,strtok(NULL, ","));
           zulu.hrs= (gpstime/10000);
           zulu.min= (gpstime - (zulu.hrs * 10000 ))/100;
           zulu.sec= (gpstime - (zulu.hrs * 10000) - (zulu.min * 100));
           _gmathrs =(zulu.hrs-12);
          // decday = (zulu.hrs);
          // decimal_day= (decday/24);
          
       /*  _gmst = 24110.54841 +  (8640184.812566 * T )
          +(0.093104 * (T^2)) - (0.0000062 * (T^3));*/
         _gmst =  ( 18.697374558 + 24.06570982441908*d);  
         GMST = (_gmst/3600  );  
}  


int ggalat()

//parse out the latitude, convert from ascii char to floating
//point. Separate the degrees minutes and seconds
//convert the seconds into SS.ss using the modf function 
//http://www.cplusplus.com/reference/cstdlib/atof/

{
  
   strcpy( nmealat,strtok(NULL, ","));   
     //  strcpy(tempf,strtok(NULL, ","));
           _lat.lat=strtof(  nmealat,NULL); 
           _lat.latdeg= (_lat.lat/100);           
           _lat.latmintemp= (_lat.lat - _lat.latdeg*100);
           _lat.param = _lat.latmintemp;
           //modf function see http://www.cplusplus.com/reference/cmath/modf/
           _lat.fractpart = modf(_lat.param , &_lat.intpart);//special function
           _lat.latmin=_lat.intpart; 
           _lat.latsec= _lat.fractpart;
           latmins = _lat.latmin;
}  



char updown()
//get the north or south keep as ascii char
{
  
  strncpy( lat_fix,strtok(NULL, ","),1); 
    
}  

char ggalong()

//get the longitude same procedure as latitude

{
  
   strcpy( nmealong,strtok(NULL, ",")); 
           longitude=atof(  nmealong); 
           longdeg= (longitude/100);
          // longmin= ((longitude - longdeg*100));
           longmintemp=((longitude - longdeg*100));
           longparam=longmintemp;
           longfractpart= modf(longparam,&longintpart);
           longmin=longintpart;
           longintmin=longmin;
         /*  longDegrees = (int)(longitude/100);
	          longMinutes = (float)(longitude - longDegrees*100);  */
} 


char leftright()

//get the east west keep as ascii char
{
  
  strncpy( L_R_fix,strtok(NULL, ","),1); 
  
  
}  


int fix()//satellite fix data
//http://www.cplusplus.com/reference/cstdlib/atoi/
{

strcpy( satfix,strtok(NULL, ",")); 
   _fix=atoi(satfix);
}




int numsat()

{

strcpy( satnum,strtok(NULL, ",")); 
_numsats= atoi(satnum);
}




char dilut()
//Horizontal Dilution of Precision (HDOP)
//Relative accuracy of horizontal position
//Shows how wide are the satellite orbits
{

strcpy( _dilut,strtok(NULL, ",")); 
diluted = atof(_dilut);
}




float altitude()

{

strcpy( alt,strtok(NULL, ",")); 
_alt = atof(alt);
}




char meters()


{
  
  strcpy( alt_char,strtok(NULL, ",")); 
  
  
}  


float geoid()


{
  
  strcpy( _geoid,strtok(NULL, ",")); 
  Gsep= atof(_geoid);
  
}  



char geoidunits()

//get the east west keep as ascii char
{
  
  strncpy( _gchar,strtok(NULL, ","),1); 
  
  
} 

float julian_date()


  {
   // dec_day= ( (zulu.hrs/24)); 
    
    JD_adder=(2000+year);
    A = (JD_adder/100);
    B = (2-A)+(A/4);
    
    JD = (365.25*JD_adder) + (30.6001*(month + 1))+ (_decday + 1720994.5 - B);
}

int fulldate( ) 
//parse out the date into individual day month year 
//variables

    {
    
     day=( _rmcdate/10000); 
     tempdate=(_rmcdate-(day * 10000));
     
     month=(tempdate/100);
     
     year= _rmcdate-((day*10000)+month*100);
   //  year=(day+tempdate)-_rmcdate;
     } 
     

 
float decimalday()

//decimal part of the day = (minutes/60 + hours)/24

   {
     int decsec;
     
     decday = (zulu.hrs);
           decimal_day= (decday/24);
   _decday= (decday + decimal_day );
   }
   
       